#include <p18cxxx.h>
#include <delays.h>
#include "LCD_4bit.h"

//Fcpu = 16MHz/4 = 4MHz Tcy = 0,25us

void _delay100us(void)
{
    Delay10TCYx(40);        //10x40x0,25us = 100us
}

void _delay15ms(void)
{
	Delay1KTCYx(60);     //1000x60x0,25 = 15ms
}
void _delay5ms(void)
{
	Delay1KTCYx(20);     //1000x20x,025 = 5ms
}
void _delay2ms(void)
{
	Delay1KTCYx(8);     //1000x8x,025 = 2ms
}

void Strobe(void)
{
    LCD_PORT|= (1<<LCD_E);
    _delay100us();		     //ustlen dat
    LCD_PORT&= ~(1<<LCD_E);
    _delay100us();		     //ustlen dat
}

//P?kaz----------------------------------------------------------------------
void Lcd_Cmd(unsigned char Cmd)
{
    LCD_PORT = (Cmd & 0xF0);
    CLR_RS;	             	 //RS = 0(p?kaz)
    Strobe();

    LCD_PORT = (Cmd & 0x0F)<<4;
    CLR_RS;	             	 //RS = 0(p?kaz)
    Strobe();

//Pokud je vsledek v podmnce nula, jedn se o
//p?kaz "Vyma? dislej" nebo "Nvrat na za?tek", kter
//vy?aduj del? interval

    if (Cmd & 0b11111100) _delay100us();else _delay2ms();
}

//Data-----------------------------------------------------------------------
void Lcd_Chr(unsigned char Chr)
{
    LCD_PORT = (Chr & 0xF0);
    SET_RS;	                //RS = 1(data)
    Strobe();

    LCD_PORT = (Chr & 0x0F)<<4;
    SET_RS;	                //RS = 1(data)
    Strobe();
}

//inicializace LCD------------------------------------------------------------
void Lcd_Init(void)
{
    _delay15ms;	         //?ekej 15ms

//Nastaven PORTu na vstup
    TRISB = 0b00000011;

//zapi? 03h 8bitov komunikace
    LCD_PORT = 0b00110000;
    Strobe();
    _delay5ms();	              //?ekej > 4,1ms

//zapi? 03h 8bitov komunikace
    Strobe();

//zapi? 03h 8bitov komunikace
    Strobe();

//4bitov komunikace
    LCD_PORT = 0b00101011;
    Strobe();

    Lcd_Cmd(0b00101000);		  //dva ?dky
    Lcd_Cmd(0b00000001);		  //sma? LCD
    Lcd_Cmd(0b00001100);		  //zapni LCD
    Lcd_Cmd(0b00000110);		  //incrementace
}

//?et?zec z ROM----------------------------------------------------------------
void Lcd_Out_ROM(const rom char *str)
{
    unsigned char x = 0;
    while(str[x]!=0)
    {
	_delay100us();
	Lcd_Chr(str[x]);
	x++;
    }
}

//?et?zec z RAM-----------------------------------------------------------------
void Lcd_Out_RAM(const ram char *str)
{
    unsigned char x = 0;
    while(str[x]!=0)
    {
	_delay100us();
	Lcd_Chr(str[x]);
	x++;
    }
}

//Nastaven ukazatele na pozici x,y-------------------------------------------
void Lcd_Gotoxy(unsigned char row,unsigned char col)
{
     switch(row)
    {
        case 1:row=0x00;break;
        case 2:row=0x40;break;
    }
    Lcd_Cmd(0b10000000 | row | col);
}


